| AI Engine Intrinsics User Guide (v2026.1)

Loading...
Searching...
No Matches
Functions
Dynamic Z buffer conjugation
Intrinsics » Vector Operations » MAC intrinsics » Multiplication » Advanced » Integer » Vector MAC » 32 bit x 16 bit » 32 bit Real x 16 bit Complex

## Overview

32 bit real by 16 bit complex using Dynamic Z buffer conjugation

## Functions
v4cacc80 | lmac4 (v4cacc80 acc, v16int32 xbuff, int xstart, unsigned int xoffsets, int xstep, v8cint16 zbuff, int zstart, unsigned int zoffsets, int zstep, bool zconj)
| Complex multiply-accumulate intrinsic function with dynamic z buffer conjugation using small X input buffer.
v4cacc80 | lmac4 (v4cacc80 acc, v32int32 xbuff, int xstart, unsigned int xoffsets, int xstep, v8cint16 zbuff, int zstart, unsigned int zoffsets, int zstep, bool zconj)
| Complex multiply-accumulate intrinsic function with dynamic z buffer conjugation .
v4cacc80 | lmsc4 (v4cacc80 acc, v16int32 xbuff, int xstart, unsigned int xoffsets, int xstep, v8cint16 zbuff, int zstart, unsigned int zoffsets, int zstep, bool zconj)
| Complex multiply-subtract intrinsic function with dynamic z buffer conjugation using small X input buffer.
v4cacc80 | lmsc4 (v4cacc80 acc, v32int32 xbuff, int xstart, unsigned int xoffsets, int xstep, v8cint16 zbuff, int zstart, unsigned int zoffsets, int zstep, bool zconj)
| Complex multiply-subtract intrinsic function with dynamic z buffer conjugation .
v4cacc80 | lmul4 (v16int32 xbuff, int xstart, unsigned int xoffsets, int xstep, v8cint16 zbuff, int zstart, unsigned int zoffsets, int zstep, bool zconj)
| Complex multiply intrinsic function with dynamic z buffer conjugation using small X input buffer.
v4cacc80 | lmul4 (v32int32 xbuff, int xstart, unsigned int xoffsets, int xstep, v8cint16 zbuff, int zstart, unsigned int zoffsets, int zstep, bool zconj)
| Complex multiply intrinsic function with dynamic z buffer conjugation .
v4cacc80 | lnegmul4 (v16int32 xbuff, int xstart, unsigned int xoffsets, int xstep, v8cint16 zbuff, int zstart, unsigned int zoffsets, int zstep, bool zconj)
| Complex multiply-negate intrinsic function with dynamic z buffer conjugation using small X input buffer.
v4cacc80 | lnegmul4 (v32int32 xbuff, int xstart, unsigned int xoffsets, int xstep, v8cint16 zbuff, int zstart, unsigned int zoffsets, int zstep, bool zconj)
| Complex multiply-negate intrinsic function with dynamic z buffer conjugation .
v4cacc48 | mac4 (v4cacc48 acc, v16int32 xbuff, int xstart, unsigned int xoffsets, int xstep, v8cint16 zbuff, int zstart, unsigned int zoffsets, int zstep, bool zconj)
| Complex multiply-accumulate intrinsic function with dynamic z buffer conjugation using small X input buffer.
v4cacc48 | mac4 (v4cacc48 acc, v32int32 xbuff, int xstart, unsigned int xoffsets, int xstep, v8cint16 zbuff, int zstart, unsigned int zoffsets, int zstep, bool zconj)
| Complex multiply-accumulate intrinsic function with dynamic z buffer conjugation .
v8cacc48 | mac8 (v8cacc48 acc, v16int32 xbuff, int xstart, unsigned int xoffsets, v8cint16 zbuff, int zstart, unsigned int zoffsets, bool zconj)
| Complex multiply-accumulate intrinsic function with dynamic z buffer conjugation using small X input buffer.
v8cacc48 | mac8 (v8cacc48 acc, v32int32 xbuff, int xstart, unsigned int xoffsets, v8cint16 zbuff, int zstart, unsigned int zoffsets, bool zconj)
| Complex multiply-accumulate intrinsic function with dynamic z buffer conjugation .
v4cacc48 | msc4 (v4cacc48 acc, v16int32 xbuff, int xstart, unsigned int xoffsets, int xstep, v8cint16 zbuff, int zstart, unsigned int zoffsets, int zstep, bool zconj)
| Complex multiply-subtract intrinsic function with dynamic z buffer conjugation using small X input buffer.
v4cacc48 | msc4 (v4cacc48 acc, v32int32 xbuff, int xstart, unsigned int xoffsets, int xstep, v8cint16 zbuff, int zstart, unsigned int zoffsets, int zstep, bool zconj)
| Complex multiply-subtract intrinsic function with dynamic z buffer conjugation .
v8cacc48 | msc8 (v8cacc48 acc, v16int32 xbuff, int xstart, unsigned int xoffsets, v8cint16 zbuff, int zstart, unsigned int zoffsets, bool zconj)
| Complex multiply-subtract intrinsic function with dynamic z buffer conjugation using small X input buffer.
v8cacc48 | msc8 (v8cacc48 acc, v32int32 xbuff, int xstart, unsigned int xoffsets, v8cint16 zbuff, int zstart, unsigned int zoffsets, bool zconj)
| Complex multiply-subtract intrinsic function with dynamic z buffer conjugation .
v4cacc48 | mul4 (v16int32 xbuff, int xstart, unsigned int xoffsets, int xstep, v8cint16 zbuff, int zstart, unsigned int zoffsets, int zstep, bool zconj)
| Complex multiply intrinsic function with dynamic z buffer conjugation using small X input buffer.
v4cacc48 | mul4 (v32int32 xbuff, int xstart, unsigned int xoffsets, int xstep, v8cint16 zbuff, int zstart, unsigned int zoffsets, int zstep, bool zconj)
| Complex multiply intrinsic function with dynamic z buffer conjugation .
v8cacc48 | mul8 (v16int32 xbuff, int xstart, unsigned int xoffsets, v8cint16 zbuff, int zstart, unsigned int zoffsets, bool zconj)
| Complex multiply intrinsic function with dynamic z buffer conjugation using small X input buffer.
v8cacc48 | mul8 (v32int32 xbuff, int xstart, unsigned int xoffsets, v8cint16 zbuff, int zstart, unsigned int zoffsets, bool zconj)
| Complex multiply intrinsic function with dynamic z buffer conjugation .
v4cacc48 | negmul4 (v16int32 xbuff, int xstart, unsigned int xoffsets, int xstep, v8cint16 zbuff, int zstart, unsigned int zoffsets, int zstep, bool zconj)
| Complex multiply-negate intrinsic function with dynamic z buffer conjugation using small X input buffer.
v4cacc48 | negmul4 (v32int32 xbuff, int xstart, unsigned int xoffsets, int xstep, v8cint16 zbuff, int zstart, unsigned int zoffsets, int zstep, bool zconj)
| Complex multiply-negate intrinsic function with dynamic z buffer conjugation .
v8cacc48 | negmul8 (v16int32 xbuff, int xstart, unsigned int xoffsets, v8cint16 zbuff, int zstart, unsigned int zoffsets, bool zconj)
| Complex multiply-negate intrinsic function with dynamic z buffer conjugation using small X input buffer.
v8cacc48 | negmul8 (v32int32 xbuff, int xstart, unsigned int xoffsets, v8cint16 zbuff, int zstart, unsigned int zoffsets, bool zconj)
| Complex multiply-negate intrinsic function with dynamic z buffer conjugation .

## Function Documentation

## ◆ lmac4() [1/2]

v4cacc80 lmac4 | ( | v4cacc80 | acc,
|  | v16int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep,
|  | bool | zconj )

Complex multiply-accumulate intrinsic function with dynamic z buffer conjugation using small X input buffer.

acc0 += z00*x00 + z01*x01
acc1 += z10*x10 + z11*x11
acc2 += z20*x20 + z21*x21
acc3 += z30*x30 + z31*x31

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint80 lanes)
  xbuff | Input buffer of 16 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmac4() [2/2]

v4cacc80 lmac4 | ( | v4cacc80 | acc,
|  | v32int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep,
|  | bool | zconj )

Complex multiply-accumulate intrinsic function with dynamic z buffer conjugation .

acc0 += z00*x00 + z01*x01
acc1 += z10*x10 + z11*x11
acc2 += z20*x20 + z21*x21
acc3 += z30*x30 + z31*x31

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint80 lanes)
  xbuff | Input buffer of 32 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmsc4() [1/2]

v4cacc80 lmsc4 | ( | v4cacc80 | acc,
|  | v16int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep,
|  | bool | zconj )

Complex multiply-subtract intrinsic function with dynamic z buffer conjugation using small X input buffer.

acc0 -= z00*x00 + z01*x01
acc1 -= z10*x10 + z11*x11
acc2 -= z20*x20 + z21*x21
acc3 -= z30*x30 + z31*x31

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint80 lanes)
  xbuff | Input buffer of 16 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmsc4() [2/2]

v4cacc80 lmsc4 | ( | v4cacc80 | acc,
|  | v32int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep,
|  | bool | zconj )

Complex multiply-subtract intrinsic function with dynamic z buffer conjugation .

acc0 -= z00*x00 + z01*x01
acc1 -= z10*x10 + z11*x11
acc2 -= z20*x20 + z21*x21
acc3 -= z30*x30 + z31*x31

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint80 lanes)
  xbuff | Input buffer of 32 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmul4() [1/2]

v4cacc80 lmul4 | ( | v16int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep,
|  | bool | zconj )

Complex multiply intrinsic function with dynamic z buffer conjugation using small X input buffer.

acc0 = z00*x00 + z01*x01
acc1 = z10*x10 + z11*x11
acc2 = z20*x20 + z21*x21
acc3 = z30*x30 + z31*x31

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmul4() [2/2]

v4cacc80 lmul4 | ( | v32int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep,
|  | bool | zconj )

Complex multiply intrinsic function with dynamic z buffer conjugation .

acc0 = z00*x00 + z01*x01
acc1 = z10*x10 + z11*x11
acc2 = z20*x20 + z21*x21
acc3 = z30*x30 + z31*x31

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  xbuff | Input buffer of 32 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lnegmul4() [1/2]

v4cacc80 lnegmul4 | ( | v16int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep,
|  | bool | zconj )

Complex multiply-negate intrinsic function with dynamic z buffer conjugation using small X input buffer.

acc0 = -( z00*x00 + z01*x01 )
acc1 = -( z10*x10 + z11*x11 )
acc2 = -( z20*x20 + z21*x21 )
acc3 = -( z30*x30 + z31*x31 )

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lnegmul4() [2/2]

v4cacc80 lnegmul4 | ( | v32int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep,
|  | bool | zconj )

Complex multiply-negate intrinsic function with dynamic z buffer conjugation .

acc0 = -( z00*x00 + z01*x01 )
acc1 = -( z10*x10 + z11*x11 )
acc2 = -( z20*x20 + z21*x21 )
acc3 = -( z30*x30 + z31*x31 )

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  xbuff | Input buffer of 32 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mac4() [1/2]

v4cacc48 mac4 | ( | v4cacc48 | acc,
|  | v16int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep,
|  | bool | zconj )

Complex multiply-accumulate intrinsic function with dynamic z buffer conjugation using small X input buffer.

acc0 += z00*x00 + z01*x01
acc1 += z10*x10 + z11*x11
acc2 += z20*x20 + z21*x21
acc3 += z30*x30 + z31*x31

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint48 lanes)
  xbuff | Input buffer of 16 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mac4() [2/2]

v4cacc48 mac4 | ( | v4cacc48 | acc,
|  | v32int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep,
|  | bool | zconj )

Complex multiply-accumulate intrinsic function with dynamic z buffer conjugation .

acc0 += z00*x00 + z01*x01
acc1 += z10*x10 + z11*x11
acc2 += z20*x20 + z21*x21
acc3 += z30*x30 + z31*x31

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint48 lanes)
  xbuff | Input buffer of 32 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mac8() [1/2]

v8cacc48 mac8 | ( | v8cacc48 | acc,
|  | v16int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | bool | zconj )

Complex multiply-accumulate intrinsic function with dynamic z buffer conjugation using small X input buffer.

acc0 += z00*x00
acc1 += z10*x10
acc2 += z20*x20
acc3 += z30*x30
acc4 += z40*x40
acc5 += z50*x50
acc6 += z60*x60
acc7 += z70*x70

Returns
  Returned accumulation vector (8 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (8 x cint48 lanes)
  xbuff | Input buffer of 16 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mac8() [2/2]

v8cacc48 mac8 | ( | v8cacc48 | acc,
|  | v32int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | bool | zconj )

Complex multiply-accumulate intrinsic function with dynamic z buffer conjugation .

acc0 += z00*x00
acc1 += z10*x10
acc2 += z20*x20
acc3 += z30*x30
acc4 += z40*x40
acc5 += z50*x50
acc6 += z60*x60
acc7 += z70*x70

Returns
  Returned accumulation vector (8 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (8 x cint48 lanes)
  xbuff | Input buffer of 32 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ msc4() [1/2]

v4cacc48 msc4 | ( | v4cacc48 | acc,
|  | v16int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep,
|  | bool | zconj )

Complex multiply-subtract intrinsic function with dynamic z buffer conjugation using small X input buffer.

acc0 -= z00*x00 + z01*x01
acc1 -= z10*x10 + z11*x11
acc2 -= z20*x20 + z21*x21
acc3 -= z30*x30 + z31*x31

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint48 lanes)
  xbuff | Input buffer of 16 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ msc4() [2/2]

v4cacc48 msc4 | ( | v4cacc48 | acc,
|  | v32int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep,
|  | bool | zconj )

Complex multiply-subtract intrinsic function with dynamic z buffer conjugation .

acc0 -= z00*x00 + z01*x01
acc1 -= z10*x10 + z11*x11
acc2 -= z20*x20 + z21*x21
acc3 -= z30*x30 + z31*x31

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint48 lanes)
  xbuff | Input buffer of 32 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ msc8() [1/2]

v8cacc48 msc8 | ( | v8cacc48 | acc,
|  | v16int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | bool | zconj )

Complex multiply-subtract intrinsic function with dynamic z buffer conjugation using small X input buffer.

acc0 -= z00*x00
acc1 -= z10*x10
acc2 -= z20*x20
acc3 -= z30*x30
acc4 -= z40*x40
acc5 -= z50*x50
acc6 -= z60*x60
acc7 -= z70*x70

Returns
  Returned accumulation vector (8 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (8 x cint48 lanes)
  xbuff | Input buffer of 16 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ msc8() [2/2]

v8cacc48 msc8 | ( | v8cacc48 | acc,
|  | v32int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | bool | zconj )

Complex multiply-subtract intrinsic function with dynamic z buffer conjugation .

acc0 -= z00*x00
acc1 -= z10*x10
acc2 -= z20*x20
acc3 -= z30*x30
acc4 -= z40*x40
acc5 -= z50*x50
acc6 -= z60*x60
acc7 -= z70*x70

Returns
  Returned accumulation vector (8 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (8 x cint48 lanes)
  xbuff | Input buffer of 32 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mul4() [1/2]

v4cacc48 mul4 | ( | v16int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep,
|  | bool | zconj )

Complex multiply intrinsic function with dynamic z buffer conjugation using small X input buffer.

acc0 = z00*x00 + z01*x01
acc1 = z10*x10 + z11*x11
acc2 = z20*x20 + z21*x21
acc3 = z30*x30 + z31*x31

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mul4() [2/2]

v4cacc48 mul4 | ( | v32int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep,
|  | bool | zconj )

Complex multiply intrinsic function with dynamic z buffer conjugation .

acc0 = z00*x00 + z01*x01
acc1 = z10*x10 + z11*x11
acc2 = z20*x20 + z21*x21
acc3 = z30*x30 + z31*x31

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  xbuff | Input buffer of 32 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mul8() [1/2]

v8cacc48 mul8 | ( | v16int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | bool | zconj )

Complex multiply intrinsic function with dynamic z buffer conjugation using small X input buffer.

acc0 = z00*x00
acc1 = z10*x10
acc2 = z20*x20
acc3 = z30*x30
acc4 = z40*x40
acc5 = z50*x50
acc6 = z60*x60
acc7 = z70*x70

Returns
  Returned accumulation vector (8 x cint48 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mul8() [2/2]

v8cacc48 mul8 | ( | v32int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | bool | zconj )

Complex multiply intrinsic function with dynamic z buffer conjugation .

acc0 = z00*x00
acc1 = z10*x10
acc2 = z20*x20
acc3 = z30*x30
acc4 = z40*x40
acc5 = z50*x50
acc6 = z60*x60
acc7 = z70*x70

Returns
  Returned accumulation vector (8 x cint48 lanes)

Parameters

  xbuff | Input buffer of 32 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ negmul4() [1/2]

v4cacc48 negmul4 | ( | v16int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep,
|  | bool | zconj )

Complex multiply-negate intrinsic function with dynamic z buffer conjugation using small X input buffer.

acc0 = -( z00*x00 + z01*x01 )
acc1 = -( z10*x10 + z11*x11 )
acc2 = -( z20*x20 + z21*x21 )
acc3 = -( z30*x30 + z31*x31 )

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ negmul4() [2/2]

v4cacc48 negmul4 | ( | v32int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep,
|  | bool | zconj )

Complex multiply-negate intrinsic function with dynamic z buffer conjugation .

acc0 = -( z00*x00 + z01*x01 )
acc1 = -( z10*x10 + z11*x11 )
acc2 = -( z20*x20 + z21*x21 )
acc3 = -( z30*x30 + z31*x31 )

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  xbuff | Input buffer of 32 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ negmul8() [1/2]

v8cacc48 negmul8 | ( | v16int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | bool | zconj )

Complex multiply-negate intrinsic function with dynamic z buffer conjugation using small X input buffer.

acc0 = -( z00*x00 )
acc1 = -( z10*x10 )
acc2 = -( z20*x20 )
acc3 = -( z30*x30 )
acc4 = -( z40*x40 )
acc5 = -( z50*x50 )
acc6 = -( z60*x60 )
acc7 = -( z70*x70 )

Returns
  Returned accumulation vector (8 x cint48 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ negmul8() [2/2]

v8cacc48 negmul8 | ( | v32int32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | bool | zconj )

Complex multiply-negate intrinsic function with dynamic z buffer conjugation .

acc0 = -( z00*x00 )
acc1 = -( z10*x10 )
acc2 = -( z20*x20 )
acc3 = -( z30*x30 )
acc4 = -( z40*x40 )
acc5 = -( z50*x50 )
acc6 = -( z60*x60 )
acc7 = -( z70*x70 )

Returns
  Returned accumulation vector (8 x cint48 lanes)

Parameters

  xbuff | Input buffer of 32 elements of type int32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zconj | Selector for conjugation in Z buffer

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.